<?php
/**
 * Sphider Version 5.5.*
 * Sphider is licensed under the GNU GPL.
 *
 * PHP version 5.4
 *
 * @category Sphider_Search
 * @package  Installation
 * @author   R. Prew  <CaptQ@blog.worldspaceflight.com>
 * @license  GNU GPL
 * @link     http://www.sphidersearch.com
 */
echo "<html>";
echo "<head>";
echo "<title>";
echo "Update version number to 5.4.0.";
echo "</title>";
echo "<LINK REL=STYLESHEET HREF='admin.css' TYPE='text/css'>";
echo "</head>";
echo "<body>";
echo "<h2>Update the database version number.</h2>";

//error_reporting(E_ERROR | E_DEPRECATED); //Development only
error_reporting(0);
$settings_dir = "../settings";
require "$settings_dir/database.php";

$error = 0;
$flag = 0;

/**
 * Update to version 3.4.0
 *
 * @return void
 */
function update340()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='3.4.0'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "3.4.0";
}

/**
 * Update to version 3.4.1
 *
 * @return void
 */
function update341()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='3.4.1'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "3.4.1";
}

/**
 * Update to version 3.4.2
 *
 * @return void
 */
function update342()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='3.4.2'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "3.4.2";
}

/**
 * Update to version 3.4.3
 *
 * @return void
 */
function update343()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='3.4.3'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "3.4.3";
}

/**
 * Update to version 3.4.4
 *
 * @return void
 */
function update344()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='3.4.4'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "3.4.4";
}

/**
 * Update to version 3.4.5
 *
 * @return void
 */
function update345()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='3.4.5'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "3.4.5";
}

/**
 * Update to version 3.5.0
 *
 * @return void
 */
function update350()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='3.5.0'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "3.5.0";
}

/**
 * Update to version 3.5.1
 *
 * @return void
 */
function update351()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='3.5.1'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "3.5.1";
}

/**
 * Update to version 3.5.2
 *
 * @return void
 */
function update352()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='3.5.2'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "3.5.2";
}

/**
 * Update to version 3.5.3
 *
 * @return void
 */
function update353()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='3.5.3'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "3.5.3";
}

/**
 * Update to version 3.6.0
 *
 * @return void
 */
function update360()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='3.6.0'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "3.6.0";
}

/**
 * Update to version 3.6.1
 *
 * @return void
 */
function update361()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='3.6.1'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "3.6.1";
}

/**
 * Update to version 4.0.0
 *
 * @return void
 */
function update400()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Create temp2 table
    $db->query(
        "CREATE TABLE ".$mysql_table_prefix."temp2 (
        link varchar(255),
        id varchar (32)
        ) ENGINE = InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='4.0.0'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "4.0.0";
}

/**
 * Update to version 4.0.1
 *
 * @return void
 */
function update401()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='4.0.1'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "4.0.1";
}

/**
 * Update to version 4.0.2
 *
 * @return void
 */
function update402()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='4.0.2'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "4.0.2";
}

/**
 * Update to version 4.1.0
 *
 * @return void
 */
function update410()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Drop temp2 table
    $db->query(
        "DROP TABLE ".$mysql_table_prefix."temp2"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='4.1.0'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "4.1.0";
}

/**
 * Update to version 4.2.0
 *
 * @return void
 */
function update420()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Modify description in links table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix."links
        MODIFY COLUMN description text"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='4.2.0'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "4.2.0";
}

/**
 * Update to version 4.2.1
 *
 * @return void
 */
function update421()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='4.2.1'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "4.2.1";
}

/**
 * Update to version 5.0.0
 *
 * @return void
 */
function update500()
{
    global $db, $mysql_table_prefix, $error, $ver;

    $db->query(
        "ALTER TABLE `".$mysql_table_prefix
        ."sites` ADD link_log bool DEFAULT '0'"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='5.0.0',
        user_agent='Sphider (sphidersearch.com)'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "5.0.0";
}

/**
 * Update to version 5.1.0
 *
 * @return void
 */
function update510()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='5.1.0',
        user_agent='Sphider (sphidersearch.com)'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "5.1.0";
}

/**
 * Update to version 5.2.1
 *
 * @return void
 */
function update521()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='5.2.1',
        user_agent='Sphider (sphidersearch.com)'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "5.2.1";
}

/**
 * Update to version 5.2.0
 *
 * @return void
 */
function update520()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='5.2.0',
        user_agent='Sphider (sphidersearch.com)'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "5.2.0";
}

/**
 * Update to version 5.3.0
 *
 * @return void
 */
function update530()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='5.3.0',
        user_agent='Sphider (sphidersearch.com)'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "5.3.0";
}

/**
 * Update to version 5.4.0
 *
 * @return void
 */
function update540()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Create new column pandoc_path in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN pandoc_path VARCHAR(45) NULL DEFAULT NULL
        AFTER catppt_path"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Create new column pause_ in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN pause_ INT NULL DEFAULT NULL
        AFTER min_delay"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Create new column pause_time in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN pause_time INT NULL DEFAULT NULL
        AFTER pause_"
    );
    
    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Create new column pause_time in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN pause_pages INT NULL DEFAULT NULL
        AFTER pause_time"
    );
    
    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Create new column cft_lang in sites table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."sites ADD COLUMN ct_lang VARCHAR(10) NOT NULL DEFAULT 'en'
        AFTER link_log"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='5.4.0',
        pandoc_path='/usr/bin/pandoc',
        pause_='0',
        pause_time='120',
        pause_pages='30'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "5.4.0";
}

/**
 * Update to version 5.4.1
 *
 * @return void
 */
function update541()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='5.4.1',
        user_agent='Sphider (sphidersearch.com)'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "5.4.1";
}

/**
 * Update to version 5.5.0
 *
 * @return void
 */
function update550()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Change column 'language' to 'slanguage'
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings CHANGE COLUMN language slanguage VARCHAR(5) NULL DEFAULT NULL"
    );
    
    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    
    // Create new column dec_separator in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN dec_separator VARCHAR(2) NULL DEFAULT NULL
        AFTER index_decimals"
    );
    
    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='5.5.0',
        dec_separator='.'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "5.5.0";
}


$state = 0;
$result = $db->query("SHOW TABLES LIKE '%settings'");
if ($result->num_rows < 1) {
    $state = 1;
} else {
    $result = $db->query(
        "SELECT version_nr FROM ".$mysql_table_prefix
        ."settings WHERE id = 1"
    );
    $row = $result->fetch_row();
    if (is_null($row[0])) {
        $row[0] = "";
    }
    if (preg_match('/[12]\.4\.[012]/', $row[0]) 
        || (preg_match('/3\.[01]\.[01]/', $row[0]))
        && !preg_match('/-PDO/', $row[0])
    ) {
        $state = 2;
    } elseif (preg_match('/3\.2\.[01]/', $row[0])) {
        $state = 3;
    } elseif (preg_match('/3\.3\.0/', $row[0])) {
        $state = 4;
    } elseif (preg_match('/3\.4\.0/', $row[0])) {
        $state = 5;
    } elseif (preg_match('/3\.4\.1/', $row[0])) {
        $state = 6;
    } elseif (preg_match('/3\.4\.2/', $row[0])) {
        $state = 7;
    } elseif (preg_match('/3\.4\.3/', $row[0])) {
        $state = 8;
    } elseif (preg_match('/3\.4\.4/', $row[0])) {
        $state = 9;
    } elseif (preg_match('/3\.4\.5/', $row[0])) {
        $state = 10;
    } elseif (preg_match('/3\.5\.0/', $row[0])) {
        $state = 11;
    } elseif (preg_match('/3\.5\.1/', $row[0])) {
        $state = 12;
    } elseif (preg_match('/3\.5\.2/', $row[0])) {
        $state = 13;
    } elseif (preg_match('/3\.5\.3/', $row[0])) {
        $state = 14;
    } elseif (preg_match('/3\.6\.0/', $row[0])) {
        $state = 15;
    } elseif (preg_match('/3\.6\.1/', $row[0])) {
        $state = 16;
    } elseif (preg_match('/4\.0\.0/', $row[0])) {
        $state = 17;
    } elseif (preg_match('/4\.0\.1/', $row[0])) {
        $state = 18;
    } elseif (preg_match('/4\.0\.2/', $row[0])) {
        $state = 19;
    } elseif (preg_match('/4\.1\.0/', $row[0])) {
        $state = 20;
    } elseif (preg_match('/4\.2\.0/', $row[0])) {
        $state = 21;
    } elseif (preg_match('/4\.2\.1/', $row[0])) {
        $state = 22;
    } elseif (preg_match('/5\.0\.0/', $row[0])) {
        $state = 23;
    } elseif (preg_match('/5\.1\.0/', $row[0])) {
        $state = 24;
    } elseif (preg_match('/5\.2\.0/', $row[0])) {
        $state = 25;
    } elseif (preg_match('/5\.2\.1/', $row[0])) {
        $state = 26;
    } elseif (preg_match('/5\.3\.0/', $row[0])) {
        $state = 27;
    } elseif (preg_match('/5\.4\.0/', $row[0])) {
        $state = 28;
    } elseif (preg_match('/5\.4\.1/', $row[0])) {
        $state = 29;
    } elseif (preg_match('/5\.5\.0/', $row[0])) {
        $state = 30;
    } elseif (preg_match('/1\.5\.[12]\.1/', $row[0])
        || preg_match('/-PDO/', $row[0])
    ) { 
        $state = 99; 
    }
}

switch ($state) {
case 0:
case 1:
    echo "Unknown Sphider version.<br>A clean install is suggested.<br>";
    exit;
case 2:
    echo "Your database needs to be updated.<br>Run 'update_to_320.php',<br>
      then run 'convert_db.php'. After that, try this update again.";
    exit;
case 3:
    echo "Your database needs to be converted.<br>Run 'convert_db.php'. 
      After that try this update again.";
    exit;
case 4:
    update340();
case 5:
    update341();
case 6:
    update342();
case 7:
    update343();
case 8:
    update344();
case 9:
    update345();
case 10:
    update350();
case 11:
    update351();
case 12:
    update352();
case 13:
    update353();
case 14:
    update360();
case 15:
    update361();
case 16:
    update400();
case 17:
    update401();
case 18:
    update402();
case 19:
    update410();
case 20:
    update420();
case 21:
    update421();
case 22:
    update500();
case 23:
    update510();
case 24:
    update520();
case 25:
    update521();
case 26:
    update530();
case 27:
    update540();
case 28:
    update541();
case 29;
    update550();
    break;
case 99;
    echo "You are attempting to upgrade a PDO version with a non-PDO version.";
    exit;
default:
    echo "You already have the latest version installed<br>";
    $flag = 1;
}

if ($error >0) {
    print "<b>Updating the database failed. Consult the above error messages.</b>";
} else {
    if (!$flag) {
        print "<b>You have successfully updated the database to version ".$ver
          .". Go to <a href='admin.php'>admin.php</a> to start indexing.</b>"; 
    }
}

echo "</body>";
echo "</html>";
