<?php
/**
 * Sphider Version 4.2.*
 * Sphider is licensed under the GNU GPL.
 *
 * PHP version 5.4
 *
 * @category Sphider_Search
 * @package  Search
 * @author   R. Prew  <CaptQ@blog.worldspaceflight.com>
 * @license  GNU GPL
 * @link     http://www.sphidersearch.com
 */
set_time_limit(300);

echo "<br>";
extract($search_results);

if ($search_results['total_results']==0) {
    echo "<div id ='result_report'>"
      .$sph_messages['theSearch']." '".$query."' "
      .$sph_messages['NotRtnImgs'].".
      </div>";
}

if ($total_results != 0 && $from <= $to) {
    echo "<div id ='result_report'>";
    $result = $sph_messages['Results'];
    $result = str_replace('%from', $from, $result);
    $result = str_replace('%to', $to, $result);
    $result = str_replace('%all', $total_results, $result);
    $matchword = $sph_messages["matches"];
    if ($total_results== 1) {
        $matchword= $sph_messages["match"];
    } else {
        $matchword= $sph_messages["matches"];
    }

    $result = str_replace('%matchword', $matchword, $result);
    $result = str_replace('%secs', $time, $result);
    echo $result
      ."</div>";
}

if (isset($qry_results)) {
    echo "<div id='i_results'>";
    // results listing
    if (extension_loaded('imagick') && $img_ok == 1) {
        echo "<div>";
        foreach ($qry_results as $_key => $_row) {
            extract($_row);
            $thumb = new Imagick();
            $imgname = $tmp_dir."/".$name;
            $tmp = @file_get_contents($imgUrl);
            if ($tmp === false) {
                echo "<div class='row'><div style='width:14%; display:table-cell;'>
                  <b>NO IMAGE PREVIEW<br>CANNOT OPEN FILE</b>";
            } else {
                file_put_contents($imgname, $tmp);
                $thumb->readImage(realpath($imgname));
                $prop = $thumb->getImageGeometry();
                if ($prop['width'] <= 200 && $prop['height'] <= 200) {
                    // do nothing
                } else {
                    $thumb->resizeImage(200, 200, imagick::FILTER_LANCZOS, 1, true);
                }
                $thumb->setImageFormat("gif");
                $savepath = $tmp_dir."/thumb_".$img_id.".gif";
                file_put_contents($savepath, $thumb);
                $thumb->clear();
                $thumb->destroy();
                echo "<div class='row'><div style='width:200px; display:table-cell;
                  height:200px; vertical-align:middle'><img src='".$savepath."'>";
            }
            echo "</div><div style='width:1%; display:table-cell;'>&nbsp;</div>
              <div style='display:table-cell; padding-top:80px;
              vertical-align:top;'>";
            if ($show_result_number == 0) {
                $num = "";
            } else {
                $num = "<b>".$num.".</b> ";
            }
            echo $num. 
              "<a href='".$imgUrl."' target='_blank'>".$imgUrl."</a><br>
              <b>".$sph_messages['ImageName'].":</b> ".$name;
            if ($alt !== "") {
                echo "<br><b>Alt tag:</b> ".$alt;
            }
            if ($width > 0) {
                echo "<br><b>Size:</b> ".$width." x ".$height;
            } else {
                echo "<br><b>Size:</b> ".$prop['width']." x ".$prop['height'];
            }
            echo "</div>
              </div><div class='row'><div style='display:table-cell;'>&nbsp;
              </div></div>";
        }
        echo "</div></div>";
    } else {
        foreach ($qry_results as $_key => $_row) {
            extract($_row);
            echo "<b>".$num.".</b> 
              <a href='".$imgUrl."' target='_blank'>".$imgUrl."</a><br>
              <b>".$sph_messages['ImageName'].":</b> ".$name;
            if ($alt !== "") {
                echo "<br><b>Alt tag:</b> ".$alt;
            }
            if ($width > 0) {
                echo "<br><b>Size:</b> ".$width." x ".$height;
            }
            echo "<br><br>";
        }
        echo "</div>";
    }
}

// links to other result pages
if (isset($other_pages)) {
    echo "<div id='other_pages'>";
    echo $sph_messages["Result page"].": ";
    if ($start >1) {
        echo "<a href=\"search.php?s=3&amp;query=".strip_tags($query ?? '')
          ."&amp;start=".$prev."&amp;search=1&amp;results=".$results_per_page
          ."&amp;type=".$type."&amp;scope=".$scope."\">"
          .$sph_messages['Previous']."</a> ";
    }

    foreach ($other_pages as $page_num) {
        if ($page_num !=$start) {
            echo "<a href=\"search.php?s=3&amp;query=".strip_tags($query ?? '')
              ."&amp;start=".$page_num."&amp;search=1&amp;results="
              .$results_per_page."&amp;type=".$type."&amp;scope=".$scope."\">"
              .$page_num."</a> ";
        } else {
            echo " <b>".$page_num."</b> ";
        }
    }

    if ($next <= $pages) {
        echo "<a href=\"search.php?s=3&amp;query=".strip_tags($query ?? '')
          ."&amp;start=".$next."&amp;search=1&amp;results=".$results_per_page
          ."&amp;type=".$type."&amp;scope=".$scope."\">".$sph_messages['Next']
          ."</a> ";
    }
    echo "</div>";

}

echo "<br>
  <div class='bottom_container'>
  <form action='search.php'>
  <input type='hidden' name='s' value='3'>
  <input type='submit' class='button' value='".$sph_messages['Reset']
    ."'></form></div>";

echo "<div class='divline'>
  </div>
  <div id='powered_by'>";
poweredBy();
echo "</div>";
