var MIN_LENGTH = 3;

$( document ).ready(function() {
    $("#keyword").keyup(function() {
        var keyword = $("#keyword").val();
        if (keyword.length >= MIN_LENGTH) {
            $.get( "js_suggest/suggest.php", { keyword: keyword } )
             .done(function( data ) {
                $('#sresults').html('');
                var results = jQuery.parseJSON(data);
                $(results).each(function(key, value) {
                    $('#sresults').append('<div class="item">' + value + '</div>');
                })

                $('.item').click(function() {
                    var text = $(this).html();
                    $('#keyword').val(text);
                })

            });
        } else {
            $('#results').html('');
        }
    });

    $("#keyword").blur(function(){
            $("#sresults").fadeOut(500);
        })
        .focus(function() {
            $("#sresults").show();
        });

});

