<?php
/**
 * Sphider Version 4.2.*
 * Sphider is licensed under the GNU GPL.
 *
 * PHP version 5.4
 *
 * @category Sphider_Search
 * @package  Search
 * @author   R. Prew  <CaptQ@blog.worldspaceflight.com>
 * @license  GNU GPL
 * @link     http://www.sphidersearch.com
 *
 * Original base code by:
 *   Ando Saabas  ando(a t)cs.ioc.ee
 */
//error_reporting(E_ERROR | E_DEPRECATED); //Development only
error_reporting(0);
session_start();
$include_dir = "./include";
require $include_dir."/commonfuncs.php";
extract(getHttpVars());

if (isset($_GET['query'])) {
    $query = preg_replace($safe_string, "", strip_tags($_GET['query']));
}
if (isset($_GET['search'])) {
    $search = preg_replace("/[^a-zA-Z0-9\s]/", "", strip_tags($_GET['search']));
}
if (isset($_GET['domain'])) {
    $domain = preg_replace("/[^a-z0-9-_.]+/", "", strip_tags($_GET['domain']));
}
if (isset($_GET['type'])) {
    $type = preg_replace("/[^a-zA-Z]/", "", strip_tags($_GET['type']));
}
if (isset($_GET['catid'])) {
    $catid = preg_replace("/[^0-9]/", "", strip_tags($_GET['catid']));
}
if (isset($_GET['category'])) {
    $category = preg_replace("/[^a-zA-Z0-9\s]/", "", strip_tags($_GET['category']));
}
if (isset($_GET['results'])) {
    $results = strip_tags($_GET['results']);
}
if (isset($_GET['start'])) {
    $start = preg_replace("/[^a-zA-Z0-9\s]/", "", strip_tags($_GET['start']));
}
if (isset($_GET['adv'])) {
    $adv = preg_replace("/[^0-9]/", "", strip_tags($_GET['adv']));
}
if (isset($_GET['scope'])) {
    $scope = preg_replace("/[^a-z0-9]\s/", "", strip_tags($_GET['scope']));
}
if (isset($_GET['dates'])) {
    $dates = preg_replace("/[^a-z]/", "", strip_tags($_GET['dates']));
}
if (isset($_REQUEST['date1'])) {
    $date1 = strip_tags($_REQUEST['date1']);
}
if (isset($_REQUEST['date2'])) {
    $date2 = strip_tags($_REQUEST['date2']);
}
if (isset($_REQUEST['date3'])) {
    $date3 = strip_tags($_REQUEST['date3']);
}
if (isset($_REQUEST['sl'])) {
    $sl = strip_tags($_REQUEST['sl']);
} else {
    if (!isset($_SESSION['sl'])) {
        $_SESSION['sl'] = "";
    }
    $sl = $_SESSION['sl'];
}
if (isset($_REQUEST['activesearch'])) {
    $activesearch = $_GET['activesearch'];
} else {
    $activesearch = 0;
}

$include_dir = "./include";
$template_dir = "./templates";
$common_template_dir = "./common_template";
$tmp_dir = "./tmp";
$img_dir = "./img";
$settings_dir = "./settings";
$language_dir = "./languages";
$calendar_dir = "./calendar";

// Flag indictating not mobile
// Will be changed if it is mobile
$is_mobile = 0;

// Flag used to display image previews
// If is a mobile device, flag will be set to 0
$img_ok = 1; 

require_once $settings_dir."/database.php";
require_once $language_dir."/en-language.php";
require_once $include_dir."/searchfuncs.php";
require_once $include_dir."/categoryfuncs.php";
require_once $calendar_dir."/classes/tc_calendar.php";

require $settings_dir."/conf.php";
$stem = stemInstance($stem_language);;
if ($sl == '') {
    $sl = $language;
}
$_SESSION['sl'] = $sl;
require $include_dir."/detectmobilebrowser.php";

require $common_template_dir."/header.php";

if (!isset($s)) {
    $s=1;
}
$tab1_funcs = Array (1=> "default");
$tab2_funcs = Array (2=> "default");
$tab3_funcs = Array (3=> "default");

if ($classic_tab ==1 && $rss_tab == 0 && $image_tab == 0) {
    $s = 1;
} elseif ($classic_tab == 0 && $rss_tab == 1 && $image_tab == 0) {
    $s = 2;
} elseif ($classic_tab == 0 && $rss_tab == 0 && $image_tab == 1) {
    $s = 3;
} elseif ($classic_tab == 1 && $rss_tab == 1 && $image_tab == 0) {
    echo "<div id='search_master'>
      <div id='tabs' style='left: 58%;'>
      <ul>";
    if (array_key_exists($s, $tab1_funcs)) {
        $tab1_funcs[$s] = "selected";
    } else {
        $tab1_funcs[$s] = "default";
    }
    if (array_key_exists($s, $tab2_funcs)) {
        $tab2_funcs[$s] = "selected";
    } else {
        $tab2_funcs[$s] = "default";
    }

    echo "<li><a href='search.php?s=1' class='"
      .$tab1_funcs[$s]."'>Search</a></li>
      <li><a href='search.php?s=2' class='"
      .$tab2_funcs[$s]."'>RSS Search</a></li>
      </ul>
      </div></div>
      <div id='main'>";
} elseif ($classic_tab == 1 && $rss_tab == 0 && $image_tab == 1) {
    echo "<div id='search_master'>
      <div id='tabs' style='left: 58%;'>
      <ul>";
    if (array_key_exists($s, $tab1_funcs)) {
        $tab1_funcs[$s] = "selected";
    } else {
        $tab1_funcs[$s] = "default";
    }
    if (array_key_exists($s, $tab3_funcs)) {
        $tab3_funcs[$s] = "selected";
    } else {
        $tab3_funcs[$s] = "default";
    }

    echo "<li><a href='search.php?s=1' class='"
      .$tab1_funcs[$s]."'>Search</a></li>
      <li><a href='search.php?s=3' class='"
      .$tab3_funcs[$s]."'>Image Search</a></li>
      </ul>
      </div></div>
      <div id='main'>";
} elseif ($classic_tab == 0 && $rss_tab == 1 && $image_tab == 1) {
    $s = 2;
    echo "<div id='search_master'>
      <div id='tabs' style='left: 58%;'>
      <ul>";
    if (array_key_exists($s, $tab2_funcs)) {
        $tab2_funcs[$s] = "selected";
    } else {
        $tab2_funcs[$s] = "default";
    }
    if (array_key_exists($s, $tab3_funcs)) {
        $tab3_funcs[$s] = "selected";
    } else {
        $tab3_funcs[$s] = "default";
    }

    echo "<li><a href='search.php?s=2' class='"
      .$tab2_funcs[$s]."'>RSS Search</a></li>
      <li><a href='search.php?s=3' class='"
      .$tab3_funcs[$s]."'>Image Search</a></li>
      </ul>
      </div></div>
      <div id='main'>";
} else {
    echo "<div id='search_master'>
      <div id='tabs' style='left: 50%;'>
      <ul>";
    if (array_key_exists($s, $tab1_funcs)) {
        $tab1_funcs[$s] = "selected";
    } else {
        $tab1_funcs[$s] = "default";
    }
    if (array_key_exists($s, $tab2_funcs)) {
        $tab2_funcs[$s] = "selected";
    } else {
        $tab2_funcs[$s] = "default";
    }
    if (array_key_exists($s, $tab3_funcs)) {
        $tab3_funcs[$s] = "selected";
    } else {
        $tab3_funcs[$s] = "default";
    }

    echo "<li><a href='search.php?s=1' class='"
      .$tab1_funcs[$s]."'>Search</a></li>
      <li><a href='search.php?s=2' class='"
      .$tab2_funcs[$s]."'>RSS Search</a></li>
      <li><a href='search.php?s=3' class='"
      .$tab3_funcs[$s]."'>Image Search</a></li>
      </ul>
      </div></div>
      <div id='main'>";
}

/**
 * Micro Time function
 * 
 * @return float Elapsed time
 */
function getMicroTime()
{
    list($usec, $sec) = explode(" ", microtime());
    return ((float)$usec + (float)$sec);
}


/**
 * Powered By message
 * 
 * @return void
 */
function poweredBy()
{
    global $sph_messages;
    print $sph_messages['Powered by'];
    echo "<a href='https://www.sphider.worldspaceflight.com/'>
      <img src='sphider-logo.png' style='vertical-align: middle; border: 
      none;' alt='Sphider'></a>";
}


/**
 * Save search results to search log
 *
 * @param string $query   The query entered
 * @param time   $elapsed Time it took to run the search
 * @param int    $results Number of results returned
 *
 * @return void
 */
function saveToLog($query, $elapsed, $results)
{
    global $mysql_table_prefix, $db;
    if ($results =="") {
        $results = 0;
    }
    $parm1 = htmlentities($query ?? '', ENT_QUOTES, 'UTF-8');
    $parm2 = (double) $elapsed;
    $parm3 = (int) $results;
    $query =  "INSERT INTO ".$mysql_table_prefix."query_log (query, time, "
      ."elapsed, results) VALUES (?, now(), ?, ?)";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("sdi", $parm1, $parm2, $parm3);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
}


/**
 * Legacy search tab
 *
 * @return void
 */
function tab1()
{
    global $include_dir, $template_dir, $common_template_dir, $tmp_dir, $adv, $sl;
    global $settings_dir, $language_dir, $calendar_dir, $mysql_table_prefix, $db;
    global $query, $search, $domain, $type, $catid, $category, $results, $start;
    global $img_dir;

    include $settings_dir."/conf.php";
    $language=$sl;

    include $language_dir."/".$language."-language.php";

    if ($type != "or" && $type != "and" && $type != "phrase") {
        $type = "and";
    }

    if (preg_match("/[^a-z0-9-.]+/", $domain ?? '')) {
        $domain="";
    }

    if ($results != "") {
        $results_per_page = $results;
    }

    if (!is_numeric($catid)) {
        $catid = "";
    }

    if (!is_numeric($category)) {
        $category = "";
    }

    if ($catid && is_numeric($catid)) {
        $tpl_['category'] = sqlFetchAll(
            'SELECT category FROM '
            .$mysql_table_prefix.'categories WHERE category_id='
            .(int)$db->real_escape_string($_REQUEST['catid'])
        );
    }

    $count_level0 = sqlFetchAll(
        'SELECT count(*) FROM '
        .$mysql_table_prefix.'categories WHERE parent_num=0'
    );
    $has_categories = 0;

    if ($count_level0) {
        $has_categories = $count_level0[0][0];
    }

    include_once $common_template_dir."/search_form.php";

    switch ($search) {
    case 1:
        if (!isset($results)) {
            $results = "";
        }
        $search_results = getSearchResults(
            $query, $start,
            $category, $type, $results, $domain
        );
        include $common_template_dir."/search_results.php";
        break;
    default:
        if ($show_categories) {
            if ($_REQUEST['catid']  && is_numeric($catid)) {
                $cat_info = getCategoryInfo($catid);
            } else {
                $cat_info = getCategoriesView();
            }
            include $common_template_dir."/categories.php";
        } else {
            echo "<div id='powered_by'>";
            poweredby();
            echo "</div>";
        }
        break;
    }
}


/**
 * RSS search tab
 *
 * @return void
 */
function tab2()
{
    global $include_dir, $template_dir, $common_template_dir, $tmp_dir, $db;
    global $settings_dir, $language_dir, $calendar_dir,  $mysql_table_prefix;
    global $query, $search, $scope, $type, $results, $start;
    global $dates, $date1, $date2, $date3, $sl, $adv;

    include $settings_dir."/conf.php";
    $language=$sl;

    include $language_dir."/".$language."-language.php";

    if ($type != "or" && $type != "and") {
        $type = "and";
    }

    if ($results != "") {
        $results_per_page = $results;
    }

    include_once $common_template_dir."/rss_search_form.php";

    switch ($search) {
    case 1:
        if (!isset($results)) {
            $results = "";
        }
        $search_results = getRssSearchResults(
            $query, $start, $type,
            $dates, $date1, $date2, $date3, $results, $scope
        );
        include $common_template_dir."/rss_search_results.php";
        break;
    default:
        echo "<div id='powered_by'>";
        poweredby();
        echo "</div>";
        break;
    }
}


/**
 * Image search tab
 *
 * @return void
 */
function tab3()
{
    global $include_dir, $template_dir, $common_template_dir, $tmp_dir, $sl,
      $settings_dir, $language_dir, $calendar_dir, $mysql_table_prefix, $db;
    global $query, $search, $scope, $type, $results, $start, $img_ok, $adv;

    include $settings_dir."/conf.php";
    $language=$sl;

    include $language_dir."/".$language."-language.php";

    if ($results != "") {
        $results_per_page = $results;
    }

    include_once $common_template_dir."/img_search_form.php";

    switch ($search) {
    case 1:
        if (extension_loaded('imagick')) {
            $files = glob($tmp_dir.'/*');
            foreach ($files as $file) {
                if ($file == "Thumbs.db") {
                    continue;
                }
                if (is_file($file)) {
                    unlink($file);
                }
            }
        }
        $search_results = getImgSearchResults(
            $query, $start, $type,
            $results, $scope
        );
        include $common_template_dir."/img_search_results.php";
        break;
    default:
        echo "<div id='powered_by'>";
        poweredby();
        echo "</div>";
        break;
    }
}


switch ($s) {
case 1:
    tab1();
    break;
case 2:
    tab2();
    break;
case 3:
    tab3();
    break;
case '':
    tab1();
    break;
}

echo "</div>";
require $common_template_dir."/footer.php";
