<?php
/**
 * Sphider Version 5.5.*
 * Sphider is licensed under the GNU GPL.
 *
 * PHP version 5.4
 *
 * @category Sphider_Search
 * @package  Admin
 * @author   R. Prew  <CaptQ@blog.worldspaceflight.com>
 * @license  GNU GPL
 * @link     http://www.sphidersearch.com
 */
require "auth.php";

if (!isset($_index_numbers)) {
    $_index_numbers=0;
}

if (!isset($_index_decimals)) {
    $_index_decimals=0;
}

if (!isset($_index_xls)) {
    $_index_xls=0;
}

if (!isset($_index_ppt)) {
    $_index_ppt=0;
}

if (!isset($_index_pdf)) {
    $_index_pdf=0;
}

if (!isset($_index_doc)) {
    $_index_doc=0;
}

if (!isset($_min_delay)) {
    $_min_delay=0;
}

if (!isset($_keep_log)) {
    $_keep_log=0;
}

if (!isset($_show_meta_description)) {
    $_show_meta_description=0;
}

if (!isset($_show_categories)) {
    $_show_categories=0;
}

if (!isset($_show_query_scores)) {
    $_show_query_scores=0;
}

if (!isset($_show_stars)) {
    $_show_stars=0;
}

if (!isset($_email_log)) {
    $_email_log=0;
}

if (!isset($_print_results)) {
    $_print_results=0;
}

if (!isset($_index_meta_keywords)) {
    $_index_meta_keywords=0;
}

if (!isset($_index_host)) {
    $_index_host=0;
}

if (!isset($_advanced_search)) {
    $_advanced_search=0;
}

if (!isset($_show_result_number)) {
    $_show_result_number=0;
}

if (!isset($_show_index_date)) {
    $_show_index_date=0;
}

if (!isset($_show_url)) {
    $_show_url=0;
}

if (!isset($_classic_tab)) {
    $_classic_tab=0;
}    

if (!isset($_rss_tab)) {
    $_rss_tab=0;
}    

if (!isset($_image_tab)) {
    $_image_tab=0;
}    

if (!isset($_merge_site_results)) {
    $_merge_site_results=0;
}

if (!isset($_did_you_mean_enabled)) {
    $_did_you_mean_enabled=0;
}

if (!isset($_stem_words)) {
    $_stem_words=0;
}

if (!isset($_strip_sessids)) {
    $_strip_sessids=0;
}

if (!isset($_suggest_enabled)) {
    $_suggest_enabled=0;
}

if (!isset($_suggest_history)) {
    $_suggest_history =0;
}

if (!isset($_suggest_phrases)) {
    $_suggest_phrases=0;
}

if (!isset($_suggest_keywords)) {
    $_suggest_keywords=0;
}

if (!isset($_suggest_rows)) {
    $_suggest_rows=0;
}

if (!isset($_bound_search_result)) {
    $_bound_search_result=0;
}

if (!isset($_length_of_link_desc)) {
    $_length_of_link_desc=0;
}

if (!isset($_windows_os)) {
    $_windows_os=0;
}

if (!isset($_weighted_keywords)) {
    $_weighted_keywords=0;
}

if (!isset($_index_images)) {
    $_index_images=0;
}

if (!isset($_pause_)) {
    $_pause_=0;
}

if (isset($Submit) && $Submit == $key) {
    $p2 = $db->real_escape_string($_slanguage);
    $p3 = $db->real_escape_string($_template);
    $p4 = $db->real_escape_string($_admin_email);
    $p5 = $db->real_escape_string($_print_results);
    if ($_windows_os) {   // allows use of Windows type paths using a backslash
        $p6 = strip_tags($_tmp_dir);
    } else {
        $p6 = $db->real_escape_string($_tmp_dir);
    }
    $p7 = $db->real_escape_string($_windows_os);
    $p8 = $db->real_escape_string($_keep_log);
    if ($_windows_os) {   // allows use of Windows type paths using a backslash
        $p9 = strip_tags($_log_dir);
    } else {
        $p9 = $db->real_escape_string($_log_dir);
    }
    $p10 = $db->real_escape_string($_log_format);
    $p11 = $db->real_escape_string($_email_log);
    $p12 = $db->real_escape_string($_min_words_per_page);
    $p13 = $db->real_escape_string($_min_word_length);
    $p14 = $db->real_escape_string($_word_upper_bound);
    $p15 = $db->real_escape_string($_index_numbers);
    $p16 = $db->real_escape_string($_index_decimals);
    $p17 = $db->real_escape_string($_dec_separator);
    $p18 = $db->real_escape_string($_index_host);
    $p19 = $db->real_escape_string($_index_meta_keywords);
    $p20 = $db->real_escape_string($_index_images);
    $p21 = $db->real_escape_string($_min_img_width);
    $p22 = $db->real_escape_string($_min_img_height);
    $p23 = $db->real_escape_string($_index_pdf);
    $p24 = $db->real_escape_string($_index_doc);
    $p25 = $db->real_escape_string($_index_xls);
    $p26 = $db->real_escape_string($_index_ppt);
   if ($_windows_os) {   // allows use of Windows type paths using a backslash
        $p27 = strip_tags($_pdftotext_path);
        $p28 = strip_tags($_catdoc_path);
        $p29 = strip_tags($_xls2csv_path);
        $p30 = strip_tags($_catppt_path);
        $p31 = strip_tags($_pandoc_path);        
    } else {
        $p27 = $db->real_escape_string($_pdftotext_path);
        $p28 = $db->real_escape_string($_catdoc_path);
        $p29 = $db->real_escape_string($_xls2csv_path);
        $p30 = $db->real_escape_string($_catppt_path);
        $p31 = $db->real_escape_string($_pandoc_path);        
    }
    // $db->real_escape_string presents problems
    // if the user agent contains an apostrophe
    $p32 = strip_tags($_user_agent);
    $p33 = $db->real_escape_string($_min_delay);
    $p34 = $db->real_escape_string($_pause_);
    $p35 = $db->real_escape_string($_pause_time);
    $p36 = $db->real_escape_string($_pause_pages);
    $p37 = $db->real_escape_string($_stem_words);
    $p38 = $db->real_escape_string($_stem_language);
    $p39 = $db->real_escape_string($_strip_sessids);
    $p40 = $db->real_escape_string($_results_per_page);
    $p41 = $db->real_escape_string($_cat_columns);
    $p42 = $db->real_escape_string($_bound_search_result);
    $p43 = $db->real_escape_string($_length_of_link_desc);
    $p44 = $db->real_escape_string($_links_to_next);
    $p45 = $db->real_escape_string($_qfloor);
    $p46 = $db->real_escape_string($_show_meta_description);
    $p47 = $db->real_escape_string($_advanced_search);
    $p48 = $db->real_escape_string($_show_result_number);
    $p49 = $db->real_escape_string($_show_index_date);
    $p50 = $db->real_escape_string($_show_url);
    $p51 = $db->real_escape_string($_show_query_scores);
    $p52 = $db->real_escape_string($_show_stars);
    $p53 = $db->real_escape_string($_show_categories);
    $p54 = $db->real_escape_string($_desc_length);
    $p55 = $db->real_escape_string($_merge_site_results);
    $p56 = $db->real_escape_string($_did_you_mean_enabled);
    $p57 = $db->real_escape_string($_classic_tab);
    $p58 = $db->real_escape_string($_rss_tab);
    $p59 = $db->real_escape_string($_image_tab);
    $p60 = $db->real_escape_string($_suggest_enabled);
    $p61 = $db->real_escape_string($_suggest_history);
    $p62 = $db->real_escape_string($_suggest_keywords);
    $p63 = $db->real_escape_string($_weighted_keywords);
    $p64 = $db->real_escape_string($_suggest_phrases);
    $p65 = $db->real_escape_string($_suggest_rows);
    $p66 = $db->real_escape_string($_title_weight);
    $p67 = $db->real_escape_string($_domain_weight);
    $p68 = $db->real_escape_string($_path_weight);
    $p69 = $db->real_escape_string($_meta_weight);

    // Don't set index_decimals to true unless index_numbers is also true
    if ($p15 == 0) { 
        $p16 = 0; 
    }
    
    // Enforce that at least one search tab is checked
    if ($p57 == 0 && $p58 == 0 && $p59 == 0) {
        $p57 = 1;
    }

 
    $query = "UPDATE ".$mysql_table_prefix."settings SET 
      slanguage = ?, template = ?, admin_email = ?, print_results = ?,
      tmp_dir = ?, windows_os = ?, keep_log = ?, log_dir = ?, log_format = ?,
      email_log = ?, min_words_per_page = ?, min_word_length = ?,
      word_upper_bound = ?, index_numbers = ?, index_decimals = ?,
      dec_separator = ?, index_host = ?, index_meta_keywords = ?,  index_images = ?,
      min_img_width = ?, min_img_height = ?, index_pdf = ?,
      index_doc = ?, index_xls = ?, index_ppt = ?, pdftotext_path = ?,
      catdoc_path = ?, xls2csv_path = ?, catppt_path = ?, pandoc_path = ?,
      user_agent = ?, min_delay = ?, pause_ = ?, pause_time = ?, pause_pages = ?,
      stem_words = ?, stem_language = ?, strip_sessids = ?, results_per_page = ?,
      cat_columns = ?, bound_search_result = ?, length_of_link_desc = ?,
      links_to_next = ?, qfloor = ?, show_meta_description = ?,
      advanced_search = ?, show_result_number = ?, show_index_date = ?,
      show_url = ?, show_query_scores = ?, show_stars = ?, show_categories = ?,
      desc_length = ?, merge_site_results = ?, did_you_mean_enabled = ?,
      classic_tab = ?, rss_tab = ?, image_tab = ?, suggest_enabled = ?,
      suggest_history = ?, suggest_keywords= ?,  weighted_keywords = ?,
      suggest_phrases = ?, suggest_rows = ?, title_weight = ?,
      domain_weight = ?, path_weight = ?, meta_weight = ? WHERE id = '1'";

    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param(
            "sssisiissiiiiiisiiiiiiiiissssssiiiiisiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii",
            $p2, $p3, $p4, $p5, $p6, $p7, $p8, $p9, $p10, $p11, $p12, $p13,
            $p14, $p15, $p16, $p17, $p18, $p19, $p20, $p21, $p22, $p23, $p24,
            $p25, $p26, $p27, $p28, $p29, $p30, $p31, $p32, $p33, $p34, $p35,
            $p36, $p37, $p38, $p39, $p40, $p41, $p42, $p43, $p44, $p45, $p46,
            $p47, $p48, $p49, $p50, $p51, $p52, $p53, $p54, $p55, $p56, $p57,
            $p58, $p59, $p60, $p61, $p62, $p63, $p64, $p65, $p66, $p67, $p68, $p69
        );
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
}

$stmt = $db->prepare(
    "SELECT * FROM "
    .$mysql_table_prefix."settings WHERE id=1"
);
if ($stmt) {
    $stmt->execute() or die("Execution failed: ".$stmt->error);
    $result = $stmt->get_result();
    $row = $result->fetch_array(MYSQLI_NUM);
    $stmt->close();
} else {
    trigger_error('Statement failed : '.$stmt->error, E_USER_ERROR);
}

echo "<div id='submenu'>&nbsp;</div>";
echo "<div id='settings'>";

echo "<form name='form1' method='post' action='admin.php'>";
echo "<input type='hidden' name='f' value='settings'>";
echo "<input type='hidden' name='Submit' value='".$key."'>";

echo "<div class='row'>";
echo "<div class='tableSubHeading'>General settings</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_version_nr' value='"
  .$row[1]."' type='hidden'>";
echo $row[1];
echo "</div>";
echo "<div class='right1'> Sphider version</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'>";
echo "<SELECT name='_slanguage'>";
echo "<option value='sq' ";
if ($row[2] == "sq") { 
    echo "selected"; 
}
echo ">Albanian</option>";
echo "<option value='am' ";
if ($row[2] == "am") { 
    echo "selected"; 
}
echo ">Amharic</option>";
echo "<option value='ar' ";
if ($row[2] == "ar") { 
    echo "selected"; 
}
echo ">Arabic</option>";
echo "<option value='bg' ";
if ($row[2] == "bg") { 
    echo "selected"; 
}
echo ">Bulgarian</option>";
echo "<option value='hr' ";
if ($row[2] == "hr") { 
    echo "selected"; 
}
echo ">Croatian</option>";
echo "<option value='zh_cn' ";
if ($row[2] == "zh_cn") { 
    echo "selected"; 
}
echo ">Simple Chinese</option>";
echo "<option value='zh_tw' ";
if ($row[2] == "zh_tw") { 
    echo "selected"; 
}
echo ">Traditional Chinese</option>";
echo "<option value='cs' ";
if ($row[2] == "cs") { 
    echo "selected"; 
}
echo ">Czech</option>";
echo "<option value='da' ";
if ($row[2] == "da") { 
    echo "selected"; 
}
echo ">Danish</option>";
echo "<option value='nl' ";
if ($row[2] == "nl") { 
    echo "selected"; 
}
echo ">Dutch</option>";
echo "<option value='en' ";
if ($row[2] == "en") { 
    echo "selected"; 
}
echo ">English</option>";
echo "<option value='et' ";
if ($row[2] == "et") { 
    echo "selected"; 
}
echo ">Estonian</option>";
echo "<option value='fi' ";
if ($row[2] == "fi") { 
    echo "selected"; 
}
echo ">Finnish</option>";
echo "<option value='fr' ";
if ($row[2] == "fr") { 
    echo "selected"; 
}
echo ">French</option>";
echo "<option value='de' ";
if ($row[2] == "de") { 
    echo "selected"; 
}
echo ">German</option>";
echo "<option value='hu' ";
if ($row[2] == "hu") { 
    echo "selected"; 
}
echo ">Hungarian</option>";
echo "<option value='it' ";
if ($row[2] == "it") { 
    echo "selected"; 
}
echo ">Italian</option>";
echo "<option value='ja' ";
if ($row[2] == "ja") { 
    echo "selected"; 
}
echo ">Japanese</option>";
echo "<option value='lv' ";
if ($row[2] == "lv") { 
    echo "selected"; 
}
echo ">Latvian</option>";
echo "<option value='no' ";
if ($row[2] == "no") { 
    echo "selected"; 
}
echo ">Norwegian</option>";
echo "<option value='fa' ";
if ($row[2] == "fa") { 
    echo "selected"; 
}
echo ">Persian (Farsi)</option>";
echo "<option value='pl' ";
if ($row[2] == "pl") { 
    echo "selected"; 
}
echo ">Polish</option>";
echo "<option value='pt' ";
if ($row[2] == "pt") { 
    echo "selected"; 
}
echo ">Portuguese</option>";
echo "<option value='ro' ";
if ($row[2] == "ro") { 
    echo "selected"; 
}
echo ">Romanian</option>";
echo "<option value='ru' ";
if ($row[2] == "ru") { 
    echo "selected"; 
}
echo ">Russian</option>";
echo "<option value='sr' ";
if ($row[2] == "sr") { 
    echo "selected"; 
}
echo ">Serbian</option>";
echo "<option value='sk' ";
if ($row[2] == "sk") { 
    echo "selected"; 
}
echo ">Slovak</option>";
echo "<option value='sl' ";
if ($row[2] == "sl") { 
    echo "selected"; 
}
echo ">Slovenian</option>";
echo "<option value='es' ";
if ($row[2] == "es") { 
    echo "selected"; 
}
echo ">Spanish</option>";
echo "<option value='sw' ";
if ($row[2] == "sw") { 
    echo "selected"; 
}
echo ">Swahili</option>";
echo "<option value='sv' ";
if ($row[2] == "sv") { 
    echo "selected"; 
}
echo ">Swedish</option>";
echo "<option value='tr' ";
if ($row[2] == "tr") { 
    echo "selected"; 
}
echo ">Turkish</option>";
echo "</SELECT>";
echo "</div>";
echo "<div class='right1'> Language (applies to search page)</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'>";
echo "<SELECT name='_template'>";
$directories = getDirContents($template_dir);
if (count($directories)>0) {
    for ($i=0; $i<count($directories); $i++) {
        $dir=$directories[$i];
        echo "<option value='".$dir."' ";
        if ($row[3] == $dir) {
            echo "selected";
        }
        echo ">".$dir."</option>";
    }
}
echo "</SELECT>";
echo "</div>";
echo "<div class='right1'>Search template</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_admin_email' value='";
echo $row[4];
echo "' type='text' id='admin_email' size='20'> </div>";
echo "<div class='right1'> Administrator e-mail address</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_print_results' type='checkbox' "
  ."id='print_results' value='1' ";
if ($row[5]==1) { 
    echo "checked"; 
}
echo "> </div>";
echo "<div class='right1'>Print spidering results to standard out</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input name='_tmp_dir' type='text'  value='";
echo $row[6];
echo "' id='tmp_dir' size='20'></div>";
echo "<div class='right1'> Temporary directory (absolute or relative to admin
  directory)</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_windows_os' type='checkbox'
  id='windows_os' value='1' ";
if ($row[7]==1) { 
    echo "checked"; 
}
echo "> </div>";
echo "<div class='right1'>Windows OS (this allows indexing of pdf, doc, xls, and
  ppt files on a Windows system)</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='tableSubHeading'>Logging settings</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_keep_log' type='checkbox' id='keep_log' "
  ."value='1' ";
if ($row[8]==1) { 
    echo "checked"; 
}
echo "> </div>";
echo "<div class='right1'> Log spidering results</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input name='_log_dir' type='text'  value='";
print $row[9];
echo "' id='log_dir' size='20'></div>";
echo "<div class='right1'> Log directory (absolute or relative to admin
  directory)</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'>";
echo "<SELECT name='_log_format'>";
echo "<option value='text' ";
if ($row[10] == 'text') { 
    echo "selected"; 
}
echo ">Text</option>";
echo "<option value='html' ";
if ($row[10] == 'html') { 
    echo "selected"; 
}
echo ">Html</option>";
echo "</SELECT></div>";
echo "<div class='right1'> Log file format</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_email_log' type='checkbox' "
  ."id='email_log' value='1' ";
if ($row[11]==1) { 
    echo "checked"; 
}
echo "> </div>";
echo "<div class='right1'> Send spidering log to e-mail</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='tableSubHeading'>Spider settings</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_min_words_per_page' value='";
echo $row[12];
echo "' type='text' id='min_words_per_page' size='5' maxlength='5'></div>";
echo "<div class='right1'> Required number of words in a page in order to be
  indexed</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_min_word_length' type='text' value='";
echo $row[13];
echo "' id='min_word_length' size='5' maxlength='2'></div>";
echo "<div class='right1'> Minimum word length in order to be indexed</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_word_upper_bound' type='text' value='";
echo $row[14];
echo "' id='word_upper_bound' size='5' maxlength='3'></div>";
echo "<div class='right1'> Keyword weight depending on the number of times it
  appears in a page is capped at this value</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_index_numbers' type='checkbox' value='1' "
  ."id='index_numbers' ";
if ($row[15]==1) { 
    echo "checked"; 
}
echo "></div>";
echo "<div class='right1'> Index numbers</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_index_decimals' type='checkbox' value='1' "
  ."id='index_decimals' ";
if ($row[16]==1) { 
    echo "checked"; 
}
echo "></div>";
echo "<div class='right1'> Index decimal numbers (Index numbers must be checked
  for this to have any effect)</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'>";
echo "<SELECT name='_dec_separator'>";
echo "<option value='.' ";
if ($row[17] == ".") { 
    echo "selected"; 
}
echo ">Decimal period</option>";
echo "<option value=',' ";
if ($row[17] == ",") { 
    echo "selected"; 
}
echo ">Decimal comma</option>";
echo "</SELECT>";
echo "</div>";
echo "<div class='right1'>Decimal separator (Also affects thousands separator)</div>";
echo "</div>";
 
echo "<div class='row'>";
echo "<div class='left1'><input name='_index_host' type='checkbox'  value='1' "
  ."id='index_host' ";
if ($row[18]==1) { 
    echo "checked"; 
}
echo "></div>";
echo "<div class='right1'> Index words in domain name and url path (does NOT
  include file name)</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_index_meta_keywords' type='checkbox'  "
  ."value='1' id='index_meta_keywords' ";
if ($row[19]==1) { 
    echo "checked"; 
}
echo "></div>";
echo "<div class='right1'> Index meta keywords</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_index_images' type='checkbox'  value='1' "
  ."id='index_images' ";
if ($row[20]==1) { 
    echo "checked"; 
}
echo "></div>";
echo "<div class='right1'> Index images</div>";
echo "</div>";

if (!extension_loaded('imagick')) {
    echo "<div class='row'><div class='left1'></div>";
    echo "<div class='right1' style='color:red;'>Imagick extension ";
    echo "is not loaded. Minimum width and height settings greater<br>";
    echo "than zero may prevent images lacking 'width' and 'height' ";
    echo "attributes from being indexed.</div></div>";
}

echo "<div class='row'>";
echo "<div class='left1'> <input name='_min_img_width' value='";
echo $row[21];
echo "' type='text' id='min_img_width' size='5' maxlength='5'></div>";
echo "<div class='right1'> Minimum image width</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input name='_min_img_height' value='";
echo $row[22];
echo "' type='text' id='min_img_height' size='5' maxlength='5'></div>";
echo "<div class='right1'> Minimum image height</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input name='_index_pdf' type='checkbox'  value='1' "
  ."id='index_pdf' ";
if ($row[23]==1) { 
    echo "checked"; 
}
echo "></div>";
echo "<div class='right1'> Index PDF files</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input name='_index_doc' type='checkbox'  value='1' "
  ."id='index_doc' ";
if ($row[24]==1) { 
    echo "checked"; 
}
echo "></div>";
echo "<div class='right1'> Index DOC, DOCX, and ODT files</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input name='_index_xls' type='checkbox'  value='1' "
  ."id='index_xls' ";
if ($row[25]==1) {
    echo "checked"; 
}
echo "></div>";
echo "<div class='right1'> Index XLS files</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input name='_index_ppt' type='checkbox'  value='1' "
  ."id='index_ppt' ";
if ($row[26]==1) { 
    echo "checked"; 
}
echo "></div>";
echo "<div class='right1'> Index PPT files</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input name='_pdftotext_path' type='text'  value='";
echo $row[27];
echo "' id='pdftotext_path'></div>";
echo "<div class='right1'>Full executable path to PDF converter</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'>";
echo "<input name='_catdoc_path' type='text'  value='";
echo $row[28];
echo "' id='catdoc_path'></div>";
echo "<div class='right1'>Full executable path to DOC converter</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input name='_xls2csv_path' type='text'  value='";
echo $row[29];
echo "' id='xls2csv_path'></div>";
echo "<div class='right1'>Full executable path to XLS converter</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'>";
echo "<input name='_catppt_path' type='text'  value='";
echo $row[30];
echo "' id='catppt_path'></div>";
echo "<div class='right1'>Full executable path to PPT converter</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'>";
echo "<input name='_pandoc_path' type='text'  value='";
echo $row[31];
echo "' id='pandoc_path'></div>";
echo "<div class='right1'>Full executable path to DOCX, ODT converter</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_user_agent' value='";
echo $row[32];
echo "' type='text' id='user_agent' size='20'></div>";
echo "<div class='right1'> User agent string (Maximum 50 characters)</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_min_delay' value='";
echo $row[33];
echo "' type='text' id='min_delay' size='5'></div>";
echo "<div class='right1'> Minimal delay between page downloads</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_pause_' type='checkbox' value='1'' ";
if ($row[34]==1) {
    echo " checked";
}
echo "></div>";
echo "<div class='right1'> Pause indexing for ";
echo "<input type='radio' name='_pause_time' value='60'";
if ($row[35]==60) {
    echo " checked";
}
echo ">1<input type='radio' name='_pause_time' value='120'";
if ($row[35]==120) {
    echo " checked";
}
echo ">2<input type='radio' name='_pause_time' value='300'";
if ($row[35]==300) {
    echo " checked";
}
echo ">5 minutes after indexing";
echo "<input type='radio' name='_pause_pages' value='10'";
if ($row[36]==10) {
    echo " checked";
}
echo ">10<input type='radio' name='_pause_pages' value='20'";
if ($row[36]==20) {
    echo " checked";
}
echo ">20<input type='radio' name='_pause_pages' value='30'";
if ($row[36]==30) {
    echo " checked";
}
echo ">30<input type='radio' name='_pause_pages' value='50'";
if ($row[36]==50) {
    echo " checked";
}
echo ">50 pages.</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_stem_words' type='checkbox'  value='1' "
  ."id='stem_words' ";
if ($row[37]==1) { 
    echo "checked"; 
}
echo "></div>";
echo "<div class='right1'> Use word stemming (e.g. find sites containing \"runs\"
  and \"running\" when searching for \"run\"). Should be enabled <i>before
  </i> indexing.</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'>";
echo "<SELECT name='_stem_language'>";
echo "<option value='Danish' ";
if ($row[38] == "Danish") { 
    echo "selected"; 
}
echo ">Danish</option>";
echo "<option value='Dutch' ";
if ($row[38] == "Dutch") { 
    echo "selected"; 
}
echo ">Dutch</option>";
echo "<option value='English' ";
if ($row[38] == "English") { 
    echo "selected"; 
}
echo ">English</option>";
echo "<option value='French' ";
if ($row[38] == "French") { 
    echo "selected"; 
}
echo ">French</option>";
echo "<option value='German' ";
if ($row[38] == "German") { 
    echo "selected"; 
}
echo ">German</option>";
echo "<option value='Italian' ";
if ($row[38] == "Italian") { 
    echo "selected"; 
}
echo ">Italian</option>";
echo "<option value='Norwegian' ";
if ($row[38] == "Norwegian") { 
    echo "selected"; 
}
echo ">Norwegian</option>";
echo "<option value='Portuguese' ";
if ($row[38] == "Portuguese") { 
    echo "selected"; 
}
echo ">Portuguese</option>";
echo "<option value='Romanian' ";
if ($row[38] == "Romanian") { 
    echo "selected"; 
}
echo ">Romanian</option>";
echo "<option value='Russian' ";
if ($row[38] == "Russian") {
    echo "selected";
}
echo ">Russian</option>";
echo "<option value='Spanish' ";
if ($row[38] == "Spanish") { 
    echo "selected"; 
}
echo ">Spanish</option>";
echo "<option value='Swedish' ";
if ($row[38] == "Swedish") { 
    echo "selected"; 
}
echo ">Swedish</option>";
echo "</SELECT>";
echo "</div>";
echo "<div class='right1'> Language to stem </div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_strip_sessids' type='checkbox'  value='1' "
  ."id='strip_sessids' ";
if ($row[39]==1) { 
    echo " checked"; 
}
echo "></div>";
echo "<div class='right1'> Strip session ids (PHPSESSID, JSESSIONID, ASPSESSIONID,
  sid).</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='tableSubHeading'>Search settings</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input type='radio' name='_results_per_page' value='10'";
if ($row[40]==10) { 
    echo " checked"; 
}
echo ">10";
echo "<input type='radio' name='_results_per_page' value='20'";
if ($row[40]==20) { 
    echo " checked"; 
}
echo ">20";
echo "<input type='radio' name='_results_per_page' value='50'";
if ($row[40]==50) { 
    echo " checked"; 
}
echo ">50</div>";
echo "<div class='right1'> Default results per page</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_cat_columns' type='text' id='cat_columns' "
  ."value='";
echo $row[41];
echo "' size='5' maxlength='2'> </div>";
echo "<div class='right1'> Number of columns in category list. If you increase this,
  you might also want to increase the category table width in the css file.</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_bound_search_result' type='text' value='";
echo $row[42];
echo "' id='bound_search_results' size='5'></div>";
echo "<div class='right1'> Bound number of search results. Can speed up searches
  on large database (should be 0)</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_length_of_link_desc' type='text' value='";
echo $row[43];
echo "' id='length_of_link_desc' size='5' maxlength='4'> </div>";
echo "<div class='right1'> The length of the description string queried from the
  database when displaying search results.  Can significantly speed up searching
  on very slow machines, if set to a lower value (eg 250 or 1000; 0 is unlimited),
  otherwise doesn't have an effect.</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_links_to_next' type='text' value='";
echo $row[44];
echo "' id='links_to_next' size='5' maxlength='2'> </div>";
echo "<div class='right1'> Number of links shown to \"next\" pages</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <SELECT name='_qfloor'>";
echo "<option value='0' ";
if ($row[45]==0) { 
    echo "selected"; 
}
echo ">0</option>";
echo "<option value='20'";
if ($row[45]==20) { 
    echo "selected"; 
}
echo ">20</option>";
echo "<option value='40'";
if ($row[45]==40) { 
    echo "selected"; 
}
echo ">40</option>";
echo "<option value='60'";
if ($row[45]==60) { 
    echo "selected"; 
}
echo ">60</option>";
echo "<option value='80'";
if ($row[45]==80) { 
    echo "selected"; 
}
echo ">80</option></SELECT></div>";
echo "<div class='right1'> Floor for query scores (0 displays all results)</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'>";
echo "<input name='_show_meta_description' type='checkbox'   value='1' "
  ."id='show_meta_description' ";
if ($row[46]==1) {
    echo "checked";
}
echo "> </div>";
echo "<div class='right1'> Show meta description in results page if it exists,
  otherwise show an extract from the page text.</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'>";
echo "<input name='_advanced_search' type='checkbox'  value='1' "
  ."id='advanced_search' ";
if ($row[47]==1) { 
    echo "checked";
}
echo "></div>";
echo "<div class='right1'>Advanced search (shows and/or) </div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'>";
echo "<input name='_show_result_number' type='checkbox'  value='1' "
  ."id='advanced_search' ";
if ($row[48]==1) { 
    echo "checked";
}
echo "></div>";
echo "<div class='right1'>Show result number </div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'>";
echo "<input name='_show_index_date' type='checkbox'  value='1' "
  ."id='advanced_search' ";
if ($row[49]==1) { 
    echo "checked";
}
echo "></div>";
echo "<div class='right1'>Show index date </div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'>";
echo "<input name='_show_url' type='checkbox'  value='1' "
  ."id='advanced_search' ";
if ($row[50]==1) { 
    echo "checked";
}
echo "></div>";
echo "<div class='right1'>Show url </div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input name='_show_query_scores' type='checkbox' "
  ."value='1' id='show_query_scores' ";
if ($row[51]==1) {
    echo "checked";
}
echo "> </div>";
echo "<div class='right1'> Show query scores</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input name='_show_stars' type='checkbox' "
  ."value='1' id='show_stars' ";
if ($row[52]==1) {
    echo "checked";
}
echo "> </div>";
echo "<div class='right1'> Show stars (Show query scores must be enabled)</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input name='_show_categories' type='checkbox' "
  ."value='1' id='show_categories' ";
if ($row[53]==1) {
    echo "checked"; 
}
echo "> </div>";
echo "<div class='right1'> Show categories</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_desc_length' type='text' id='desc_length' "
  ."size='5' maxlength='4' value='";
echo $row[54];
echo "'> </div>";
echo "<div class='right1'> Maximum length of page summary displayed in search
  results</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input name='_did_you_mean_enabled' type='checkbox' "
  ."value='1' id='did_you_mean_enabled' ";
if ($row[56]==1) { 
    echo "checked"; 
}
echo "> </div>";
echo "<div class='right1'> Enable spelling suggestions (Did you mean...)</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input name='_merge_site_results' type='checkbox' "
  ."value='1' id='merge_site_results' ";
if ($row[55]==1) {
    echo "checked"; 
}
echo "> </div>";
echo "<div class='right1'> Show only the 2 most relevant links from each site
  (a la google)</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'></div><div class='tableSubSubHeading'>Form selection</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'>";
echo "<input name='_classic_tab' type='checkbox'  value='1' "
  ."id='classic_tab' ";
if ($row[57]==1) {
    echo "checked";
}
echo "></div>";
echo "<div class='right1'>Display the classic search form </div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'>";
echo "<input name='_rss_tab' type='checkbox'  value='1' "
  ."id='rss_tab' ";
if ($row[58]==1) {
    echo "checked";
}
echo "></div>";
echo "<div class='right1'>Display the RSS search form </div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'>";
echo "<input name='_image_tab' type='checkbox'  value='1' "
  ."id='image_tab' ";
if ($row[59]==1) {
    echo "checked";
}
echo "></div>";
echo "<div class='right1'>Display the image search form </div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'></div><div class='tableSubSubHeading'>Suggest</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input name='_suggest_enabled' type='checkbox' "
  ."value='1' id='_suggest_enabled' ";
if ($row[60]==1) { 
    echo "checked"; 
}
echo "> </div>";

echo "<div class='right1'> Enable Sphider Suggest </div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input name='_suggest_history' type='checkbox' "
  ."value='1' id='_suggest_history' ";
if ($row[61]==1) { 
    echo "checked";
}
echo "> </div>";
echo "<div class='right1'> Search for suggestions in query log (If enabled,
  these suggestions take priority over others.)</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input name='_suggest_keywords' type='checkbox' "
  ."value='1' id='_suggest_keywords' ";
if ($row[62]==1) {
    echo "checked";
}
echo "> </div>";
echo "<div class='right1'> Search for suggestions in keywords</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input name='_weighted_keywords' type='checkbox' "
  ."value='1' id='_weighted_keywords' ";
if ($row[63]==1) { 
    echo "checked"; 
}
echo "></div>";
echo "<div class='right1'> Use weighting when suggesting keywords</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'> <input name='_suggest_phrases' type='checkbox' "
  ."value='1' id='_suggest_phrases' ";
if ($row[64]==1) { 
    echo "checked"; 
}
echo "> </div>";
echo "<div class='right1'> Search for suggestions in phrases (If this option
  is checked, keywords setting will be ignored.)</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_suggest_rows' type='text' "
  ."id='_suggest_rows' size='3' maxlength='2' value='";
echo $row[65];
echo "'> </div>";
echo "<div class='right1'> Limit number of suggestions</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='tableSubHeading'>Weights</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_title_weight' type='text' "
  ."id='title_weight' size='5' maxlength='2' value='";
echo $row[66];
echo "'> </div>";
echo "<div class='right1'> Relative weight of a word in the title of a webpage
  </div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_domain_weight' type='text' "
  ."id='domain_weight' size='5' maxlength='2' value='";
echo $row[67];
echo "'> </div>";
echo "<div class='right1'> Relative weight of a word in the domain name</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_path_weight' type='text' "
  ."id='path_weight' size='5' maxlength='2' value='";
echo $row[68];
echo "'> </div>";
echo "<div class='right1'> Relative weight of a word in the path name</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div class='left1'><input name='_meta_weight' type='text' "
  ."id='meta_weight' size='5' maxlength='2' value='";
echo $row[69];
echo "'> </div>";
echo "<div class='right1'> Relative weight of a word in meta_keywords</div>";
echo "</div>";

echo "<div class='row'>";
echo "<div style='text-align:center;' colspan='2'><br/> <input "
  ."type='submit' value='Save settings' id='submit'></div>";
echo "</div>";

echo "</form>";

echo "</div>";
