<?php
/**
 * Sphider Version 4.2.*
 * Sphider is licensed under the GNU GPL.
 *
 * PHP version 5.4
 *
 * @category Sphider_Search
 * @package  Admin
 * @author   R. Prew  <CaptQ@blog.worldspaceflight.com>
 * @license  GNU GPL
 * @link     http://www.sphidersearch.com
 *
 * Original base code by:
 *   Ando Saabas  ando(a t)set.ee
 */
error_reporting(E_ERROR | E_DEPRECATED); //Development only
//error_reporting(0);
extract($_POST);
extract($_REQUEST);
require "auth.php";
$backup_path="./backup/";
$dbname = $database;
$dbprefix = $mysql_table_prefix;

if (isset($send2)) {
    include "db_backup.php";
}

echo "<div id='submenu'>
  </div>
  <div class='db_container'>
  <div class='row'>
  <div style='display:table-cell; vertical-align:top; text-align:center;'>";

if (!get_extension_funcs('zlib')) {
    echo "Compression module status notice: <span style='color:red;'>"
      ."Zlib is NOT installed on the server! Backup disabled!</span>";
}

echo "</div>"; //column
echo "</div>"; //row
echo "</div>"; //container

echo "<form name='dobackup' id='dobackup' method='post' action='admin.php'>
  <input type='hidden' name='f' value='database'>
  <input type='hidden' name='Submit' value='".$key."'>
  <div class='db_container'>
  <div class='row' style='background-color: #EEE;;'>
  <div class='col1' style='text-align:center;'><b>Tables</b></div>
  <div class='col2'><b>Rows</b></div>
  <div class='col3'><b>Created on</b></div>
  <div class='col4'><b>Data Size kB</b></div>
  <div class='col5'><b>Index Size kB</b></div>
  </div>";

$query = "SHOW TABLE STATUS FROM ".$dbname." LIKE '".$dbprefix."%'";
$stmt = $db->prepare($query);
if ($stmt) {
    $stmt->execute() or die("Execution failed: ".$stmt->error);
    $stats = $stmt->get_result();
    $stmt->close();
} else {
    trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
}

$bgcolor='#F2F2F2';
$i=0;
while ($rows=$stats->fetch_array(MYSQLI_ASSOC) ) {
    $stmt = $db->prepare("SELECT COUNT(*) FROM ".$rows['Name']."");
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $rowresult = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $rowrow=$rowresult->fetch_array(MYSQLI_NUM);
    $rcount = $rowrow[0];
    echo "<div class='row' style='background-color:".$bgcolor."'><div class='col0'>
      <input type='checkbox' id='tables$i' class='check' name='tables[$i]' value='"
      .$rows["Name"]."' ></div>
      <div class='col1' style='text-align:left;'>"
      .$rows["Name"]."</div>
      <div class='col2' style='text-align:center;'>".$rcount."</div>
      <div class='col3' style='text-align:center;'>"
      .$rows['Create_time']."</div>
      <div class='col4' style='text-align:center;'>"
      .number_format($rows['Data_length']/1024, 1)."</div>
      <div class='col5' style='text-align:center;'>"
      .number_format($rows['Index_length']/1024, 1)."</div></div>";
    $i++;
    if ($bgcolor=='#F2F2F2') {
        $bgcolor='white';
    } else {
        $bgcolor='#F2F2F2';
    }
}
if ($i==0) {
    echo("ERROR: Database contains no tables");
}

echo "<div class='row'>
  <input type='checkbox' name='chg' onclick=\"checkAll(document.getElementById"
  ."('dobackup'),'check',this);\"><b>Check all tables</b>
  </div>
  </div><br>
  <div class='db_container'>
  <div class='row'>
  <div style='color:#990000; font-size:xx-small; font-weight:bold;
  padding-left:39%'> Backup File Name: 
  <input name='filename' type='text' class='textbox' id='filename' "
  ."size='20' maxlength='25' value='$dbname.sql.gz'>&nbsp;
  <input  id='submitbak' ";
if (!get_extension_funcs('zlib')) {
    echo 'disabled';
}
echo "type='submit' name='send2' value='Backup'>
  </div>
  </div>
  <div class='row'></div>
  <div class='row'>
  <div style='padding-left:39%;'>
  Backup structure only
  <input type='checkbox' name='structonly' value='Yes'>
  </div>
  </div>
  <div class='row'>&nbsp;</div>
  <div class='row'>
  <div style='padding-left:39%;'>
  Restore default settings
  <input id='submit' type='submit' name='send2' value='RestoreSettings'>
  </div>
  </div>
  </div>
  </form>
  <br>
  <div class='db_container'>
  <div class='row'>
  <div style='display:table-cell; vertical-align:top;'>";
// Restore tables
if (isset($file) && $del==0 && $Submit==$key) {
    if (preg_match('/gz/', $file ?? '')) {
        @unlink($backup_path."backup.sql");
        $fp = @fopen($backup_path."backup.sql", "w");
        fwrite($fp, "");
        fclose($fp);
        chmod($backup_path."backup.sql", 0777);
        $fp = @fopen($backup_path."backup.sql", "w");
        $zp = @gzopen($backup_path.$file, "rb");
        if (!$fp) {
            die("No sql file can be created");
        }
        if (!$zp) {
            die("Cannot read zip file");
        }

        while (!gzeof($zp)) {
            $data=gzgets($zp, 8192);// buffer php
            fwrite($fp, $data);
        }
        fclose($fp);
        gzclose($zp);
        $file="backup.sql";

        flush();
        set_time_limit(500);
        exec(
            "mysql --defaults-file=".$settings_dir
            ."/my.cnf $dbname < ./backup/backup.sql"
        );

        @unlink($backup_path.$file);
        echo "<div style='width:94%;'><div class='row'><div><b>Your restore request
            was processed.</b>If you did not receive any errors on the screen, then
            you should find that your database tables have been restored.<br>
            </div></div></div>";
    }
}

// Delete backup file
if (isset($file) && $del==1 && $Submit==$key) {
    @unlink($backup_path.$file);
}

echo "</div>"; //column
echo "</div>"; //row
echo "<div class='row'>
  <div>";

if (!is_dir($backup_path)) {
    mkdir($backup_path, 0766);
}

$dir = opendir($backup_path);
$bgcolor='#F2F2F2';
$is_first=1;

while ($file = readdir($dir)) {
    if ($file != "." && $file != ".." &&  (preg_match('%\.sql%i', $file ?? '')
        || preg_match('%\.gz%i', $file ?? ''))
    ) {
        if ($is_first==1) {
            echo "<div class='row' style='background-color:#EEE;'>
              <div style='width:30%; text-align:center; "
              ."display:table-cell;'><b>File</b></div>
              <div style='width:20%; text-align:center; "
              ."display:table-cell;'><b>Size</b></div>
              <div style='width:20%; text-align:center; "
              ."display:table-cell;'><b>Date</b></div>
              <div style='display:table-cell;'>&nbsp;</div></div>";
        }
        $is_first=0;
        echo "<div class='row' style='background-color:".$bgcolor.";'>"
          ."<div style='text-align:center; white-space:nowrap;"
          ." display:table-cell; width:30%;'>$file</div>
          <div style='text-align:center; white-space:nowrap; display:table-cell;
          width: 20%;'>".round(filesize($backup_path.$file) / 1024, 2)." kB</div>
          <div style='text-align:center; white-space:nowrap; display:table-cell;
          width:20%;'>".date("Y-m-d", filemtime($backup_path.$file))."</div>
          <div style='text-align:left; white-space:nowrap; display:table-cell;'>
          <input type='button' id='submitres' onclick=\"confirm_rest_prompt
          ('./admin.php?f=database&amp;file=$file&amp;del=0&amp;Submit=".$key."');\"
          value='Restore'> &nbsp;
		  <input type='button' id='submitdel' onclick=\"confirm_del_prompt
		  ('./admin.php?f=database&amp;file=$file&amp;del=1&amp;Submit=".$key."');\"
		  value='Delete'></div>
          </div>"; //row

        if ($bgcolor=='#F2F2F2') {
            $bgcolor='white';
        } else {
            $bgcolor='#F2F2F2';
        }
    }

}
closedir($dir);

echo "</div>"; //container
echo "</div>"; //row
echo "</div>"; //container
