<?php
/**
 * Sphider Version 4.2.*
 * Sphider is licensed under the GNU GPL.
 *
 * PHP version 5.4
 *
 * @category Sphider_Search
 * @package  Search
 * @author   R. Prew  <CaptQ@blog.worldspaceflight.com>
 * @license  GNU GPL
 * @link     http://www.sphidersearch.com
 */
echo "<br>";
extract($search_results);

if ($search_results['total_results']==0) {
    echo "<div id ='result_report'>"
      ,$sph_messages['theSearch']." '".$query."' "
      .$sph_messages['NotRtnFeeds'].".
      </div>";
}

if ($total_results != 0 && $from <= $to) {
    echo "<div id ='result_report'>";
    $result = $sph_messages['Results'];
    $result = str_replace('%from', $from, $result);
    $result = str_replace('%to', $to, $result);
    $result = str_replace('%all', $total_results, $result);
    $matchword = $sph_messages["matches"];
    if ($total_results== 1) {
        $matchword= $sph_messages["match"];
    } else {
        $matchword= $sph_messages["matches"];
    }

    $result = str_replace('%matchword', $matchword, $result);
    $result = str_replace('%secs', $time, $result);
    echo $result
      ."</div>";
}

if (isset($qry_results)) {
    echo "<div id='r_results'>";
    // results listing
    foreach ($qry_results as $_key => $_row) {
        extract($_row);
        if ($show_result_number == 0) {
            $num = "";
        } else {
            $num = "<b>".$num.".</b> ";
        }
        echo $num."<span class='title'>".$title."</span><br>";
        echo "<a href='".$link."' target='_blank'>".$link."</a><br>";
        echo "<b>".$sph_messages["PubDate"].":</b> ".$pubDate." by: ".$feed_title
          ."<br><br>";
    }
    echo "</div>";
}

// links to other result pages
if (isset($other_pages)) {
    echo "<div id='other_pages'>"
      .$sph_messages["Result page"].": ";
    if ($start >1) {
        echo "<a href=\"search.php?s=2&amp;query=".strip_tags($query ?? '')
          ."&amp;start=".$prev."&amp;search=1&amp;results=".$results_per_page
          ."&amp;type=".$type."&amp;dates=".$dates."&amp;date1=".$date1."&amp;date2="
          .$date2."&amp;date3=".$date3."&amp;scope=".$scope."\">"
          .$sph_messages['Previous']."</a> ";
    }

    foreach ($other_pages as $page_num) {
        if ($page_num !=$start) {
            echo "<a href=\"search.php?s=2&amp;query=".strip_tags($query ?? '')
              ."&amp;start=".$page_num."&amp;search=1&amp;results="
              .$results_per_page."&amp;type=".$type."&amp;dates=".$dates
              ."&amp;date1=".$date1."&amp;date2=".$date2."&amp;date3=".$date3
              ."&amp;scope=".$scope."\">".$page_num."</a> ";
        } else {
            echo " <b>".$page_num."</b> ";
        }
    }

    if ($next <= $pages) {
        echo "<a href=\"search.php?s=2&amp;query=".strip_tags($query ?? '')
          ."&amp;start=".$next."&amp;search=1&amp;results=".$results_per_page
          ."&amp;type=".$type."&amp;dates=".$dates."&amp;date1=".$date1
          ."&amp;date2=".$date2."&amp;date3=".$date3."&amp;scope=".$scope
          ."\">".$sph_messages['Next']."</a> ";
    }
    echo "</div>";
}

echo "<br>
  <div class='bottom_container'>
  <form action='search.php'>
  <input type='hidden' name='s' value='2'>
  <input type='submit' class='button' value='".$sph_messages['Reset']
    ."'></form></div>";

echo "<div class='divline'>
  </div>
  <div id='powered_by'>";
poweredBy();
echo "</div>";
